diff --git a/drivers/hwmon/f71882fg.c b/drivers/hwmon/f71882fg.c
index 19b6c643059a7..70121482a6173 100644
--- a/drivers/hwmon/f71882fg.c
+++ b/drivers/hwmon/f71882fg.c
@@ -292,968 +285,116 @@ struct f71882fg_data {
 	s8	pwm_auto_point_temp[4][4];
 };
 
-/* Sysfs in */
-static ssize_t show_in(struct device *dev, struct device_attribute *devattr,
-	char *buf);
-static ssize_t show_in_max(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_in_max(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_in_beep(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_in_beep(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_in_alarm(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-/* Sysfs Fan */
-static ssize_t show_fan(struct device *dev, struct device_attribute *devattr,
-	char *buf);
-static ssize_t show_fan_full_speed(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_fan_full_speed(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_fan_beep(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_fan_beep(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_fan_alarm(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-/* Sysfs Temp */
-static ssize_t show_temp(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t show_temp_max(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_temp_max(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_temp_max_hyst(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_temp_max_hyst(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_temp_crit(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_temp_crit(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_temp_crit_hyst(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t show_temp_type(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t show_temp_beep(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t store_temp_beep(struct device *dev, struct device_attribute
-	*devattr, const char *buf, size_t count);
-static ssize_t show_temp_alarm(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-static ssize_t show_temp_fault(struct device *dev, struct device_attribute
-	*devattr, char *buf);
-/* PWM and Auto point control */
-static ssize_t show_pwm(struct device *dev, struct device_attribute *devattr,
-	char *buf);
-static ssize_t store_pwm(struct device *dev, struct device_attribute *devattr,
-	const char *buf, size_t count);
-static ssize_t show_simple_pwm(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_simple_pwm(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_pwm_enable(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_enable(struct device *dev,
-	struct device_attribute	*devattr, const char *buf, size_t count);
-static ssize_t show_pwm_interpolate(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_interpolate(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_pwm_auto_point_channel(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_auto_point_channel(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_pwm_auto_point_temp_hyst(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_auto_point_temp_hyst(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_pwm_auto_point_pwm(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_auto_point_pwm(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-static ssize_t show_pwm_auto_point_temp(struct device *dev,
-	struct device_attribute *devattr, char *buf);
-static ssize_t store_pwm_auto_point_temp(struct device *dev,
-	struct device_attribute *devattr, const char *buf, size_t count);
-/* Sysfs misc */
-static ssize_t name_show(struct device *dev, struct device_attribute *devattr,
-	char *buf);
+static u8 f71882fg_read8(struct f71882fg_data *data, u8 reg)
+{
+	u8 val;
 
-static int f71882fg_probe(struct platform_device *pdev);
-static int f71882fg_remove(struct platform_device *pdev);
+	outb(reg, data->addr + ADDR_REG_OFFSET);
+	val = inb(data->addr + DATA_REG_OFFSET);
 
-static struct platform_driver f71882fg_driver = {
-	.driver = {
-		.name	= DRVNAME,
-	},
-	.probe		= f71882fg_probe,
-	.remove		= f71882fg_remove,
-};
+	return val;
+}
 
-static DEVICE_ATTR_RO(name);
+static u16 f71882fg_read16(struct f71882fg_data *data, u8 reg)
+{
+	u16 val;
 
-/*
- * Temp attr for the f71858fg, the f71858fg is special as it has its
- * temperature indexes start at 0 (the others start at 1)
- */
-static struct sensor_device_attribute_2 f71858fg_temp_attr[] = {
-	SENSOR_ATTR_2(temp1_input, S_IRUGO, show_temp, NULL, 0, 0),
-	SENSOR_ATTR_2(temp1_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 0),
-	SENSOR_ATTR_2(temp1_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 0),
-	SENSOR_ATTR_2(temp1_max_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 0),
-	SENSOR_ATTR_2(temp1_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 0),
-	SENSOR_ATTR_2(temp1_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 0),
-	SENSOR_ATTR_2(temp1_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 4),
-	SENSOR_ATTR_2(temp1_fault, S_IRUGO, show_temp_fault, NULL, 0, 0),
-	SENSOR_ATTR_2(temp2_input, S_IRUGO, show_temp, NULL, 0, 1),
-	SENSOR_ATTR_2(temp2_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 1),
-	SENSOR_ATTR_2(temp2_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 1),
-	SENSOR_ATTR_2(temp2_max_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 1),
-	SENSOR_ATTR_2(temp2_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 1),
-	SENSOR_ATTR_2(temp2_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 1),
-	SENSOR_ATTR_2(temp2_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 5),
-	SENSOR_ATTR_2(temp2_fault, S_IRUGO, show_temp_fault, NULL, 0, 1),
-	SENSOR_ATTR_2(temp3_input, S_IRUGO, show_temp, NULL, 0, 2),
-	SENSOR_ATTR_2(temp3_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 2),
-	SENSOR_ATTR_2(temp3_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 2),
-	SENSOR_ATTR_2(temp3_max_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 2),
-	SENSOR_ATTR_2(temp3_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 2),
-	SENSOR_ATTR_2(temp3_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 2),
-	SENSOR_ATTR_2(temp3_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 6),
-	SENSOR_ATTR_2(temp3_fault, S_IRUGO, show_temp_fault, NULL, 0, 2),
-};
+	val  = f71882fg_read8(data, reg) << 8;
+	val |= f71882fg_read8(data, reg + 1);
 
-/* Temp attr for the standard models */
-static struct sensor_device_attribute_2 fxxxx_temp_attr[3][9] = { {
-	SENSOR_ATTR_2(temp1_input, S_IRUGO, show_temp, NULL, 0, 1),
-	SENSOR_ATTR_2(temp1_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 1),
-	SENSOR_ATTR_2(temp1_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 1),
-	/*
-	 * Should really be temp1_max_alarm, but older versions did not handle
-	 * the max and crit alarms separately and lm_sensors v2 depends on the
-	 * presence of temp#_alarm files. The same goes for temp2/3 _alarm.
-	 */
-	SENSOR_ATTR_2(temp1_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 1),
-	SENSOR_ATTR_2(temp1_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 1),
-	SENSOR_ATTR_2(temp1_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 1),
-	SENSOR_ATTR_2(temp1_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 5),
-	SENSOR_ATTR_2(temp1_type, S_IRUGO, show_temp_type, NULL, 0, 1),
-	SENSOR_ATTR_2(temp1_fault, S_IRUGO, show_temp_fault, NULL, 0, 1),
-}, {
-	SENSOR_ATTR_2(temp2_input, S_IRUGO, show_temp, NULL, 0, 2),
-	SENSOR_ATTR_2(temp2_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 2),
-	SENSOR_ATTR_2(temp2_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 2),
-	/* Should be temp2_max_alarm, see temp1_alarm note */
-	SENSOR_ATTR_2(temp2_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 2),
-	SENSOR_ATTR_2(temp2_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 2),
-	SENSOR_ATTR_2(temp2_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 2),
-	SENSOR_ATTR_2(temp2_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 6),
-	SENSOR_ATTR_2(temp2_type, S_IRUGO, show_temp_type, NULL, 0, 2),
-	SENSOR_ATTR_2(temp2_fault, S_IRUGO, show_temp_fault, NULL, 0, 2),
-}, {
-	SENSOR_ATTR_2(temp3_input, S_IRUGO, show_temp, NULL, 0, 3),
-	SENSOR_ATTR_2(temp3_max, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 3),
-	SENSOR_ATTR_2(temp3_max_hyst, S_IRUGO|S_IWUSR, show_temp_max_hyst,
-		store_temp_max_hyst, 0, 3),
-	/* Should be temp3_max_alarm, see temp1_alarm note */
-	SENSOR_ATTR_2(temp3_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 3),
-	SENSOR_ATTR_2(temp3_crit, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 3),
-	SENSOR_ATTR_2(temp3_crit_hyst, S_IRUGO, show_temp_crit_hyst, NULL,
-		0, 3),
-	SENSOR_ATTR_2(temp3_crit_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 7),
-	SENSOR_ATTR_2(temp3_type, S_IRUGO, show_temp_type, NULL, 0, 3),
-	SENSOR_ATTR_2(temp3_fault, S_IRUGO, show_temp_fault, NULL, 0, 3),
-} };
+	return val;
+}
 
-/* Temp attr for models which can beep on temp alarm */
-static struct sensor_device_attribute_2 fxxxx_temp_beep_attr[3][2] = { {
-	SENSOR_ATTR_2(temp1_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 1),
-	SENSOR_ATTR_2(temp1_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 5),
-}, {
-	SENSOR_ATTR_2(temp2_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 2),
-	SENSOR_ATTR_2(temp2_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 6),
-}, {
-	SENSOR_ATTR_2(temp3_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 3),
-	SENSOR_ATTR_2(temp3_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 7),
-} };
+static inline int fan_from_reg(u16 reg)
+{
+	return reg ? (1500000 / reg) : 0;
+}
 
-static struct sensor_device_attribute_2 f81866_temp_beep_attr[3][2] = { {
-	SENSOR_ATTR_2(temp1_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 0),
-	SENSOR_ATTR_2(temp1_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 4),
-}, {
-	SENSOR_ATTR_2(temp2_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 1),
-	SENSOR_ATTR_2(temp2_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 5),
-}, {
-	SENSOR_ATTR_2(temp3_max_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 2),
-	SENSOR_ATTR_2(temp3_crit_beep, S_IRUGO|S_IWUSR, show_temp_beep,
-		store_temp_beep, 0, 6),
-} };
+static inline u16 fan_to_reg(int fan)
+{
+	return fan ? (1500000 / fan) : 0;
+}
 
-/*
- * Temp attr for the f8000
- * Note on the f8000 temp_ovt (crit) is used as max, and temp_high (max)
- * is used as hysteresis value to clear alarms
- * Also like the f71858fg its temperature indexes start at 0
- */
-static struct sensor_device_attribute_2 f8000_temp_attr[] = {
-	SENSOR_ATTR_2(temp1_input, S_IRUGO, show_temp, NULL, 0, 0),
-	SENSOR_ATTR_2(temp1_max, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 0),
-	SENSOR_ATTR_2(temp1_max_hyst, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 0),
-	SENSOR_ATTR_2(temp1_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 4),
-	SENSOR_ATTR_2(temp1_fault, S_IRUGO, show_temp_fault, NULL, 0, 0),
-	SENSOR_ATTR_2(temp2_input, S_IRUGO, show_temp, NULL, 0, 1),
-	SENSOR_ATTR_2(temp2_max, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 1),
-	SENSOR_ATTR_2(temp2_max_hyst, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 1),
-	SENSOR_ATTR_2(temp2_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 5),
-	SENSOR_ATTR_2(temp2_fault, S_IRUGO, show_temp_fault, NULL, 0, 1),
-	SENSOR_ATTR_2(temp3_input, S_IRUGO, show_temp, NULL, 0, 2),
-	SENSOR_ATTR_2(temp3_max, S_IRUGO|S_IWUSR, show_temp_crit,
-		store_temp_crit, 0, 2),
-	SENSOR_ATTR_2(temp3_max_hyst, S_IRUGO|S_IWUSR, show_temp_max,
-		store_temp_max, 0, 2),
-	SENSOR_ATTR_2(temp3_alarm, S_IRUGO, show_temp_alarm, NULL, 0, 6),
-	SENSOR_ATTR_2(temp3_fault, S_IRUGO, show_temp_fault, NULL, 0, 2),
-};
+static void f71882fg_write8(struct f71882fg_data *data, u8 reg, u8 val)
+{
+	outb(reg, data->addr + ADDR_REG_OFFSET);
+	outb(val, data->addr + DATA_REG_OFFSET);
+}
 
-/* in attr for all models */
-static struct sensor_device_attribute_2 fxxxx_in_attr[] = {
-	SENSOR_ATTR_2(in0_input, S_IRUGO, show_in, NULL, 0, 0),
-	SENSOR_ATTR_2(in1_input, S_IRUGO, show_in, NULL, 0, 1),
-	SENSOR_ATTR_2(in2_input, S_IRUGO, show_in, NULL, 0, 2),
-	SENSOR_ATTR_2(in3_input, S_IRUGO, show_in, NULL, 0, 3),
-	SENSOR_ATTR_2(in4_input, S_IRUGO, show_in, NULL, 0, 4),
-	SENSOR_ATTR_2(in5_input, S_IRUGO, show_in, NULL, 0, 5),
-	SENSOR_ATTR_2(in6_input, S_IRUGO, show_in, NULL, 0, 6),
-	SENSOR_ATTR_2(in7_input, S_IRUGO, show_in, NULL, 0, 7),
-	SENSOR_ATTR_2(in8_input, S_IRUGO, show_in, NULL, 0, 8),
-	SENSOR_ATTR_2(in9_input, S_IRUGO, show_in, NULL, 0, 9),
-	SENSOR_ATTR_2(in10_input, S_IRUGO, show_in, NULL, 0, 10),
-};
+static void f71882fg_write16(struct f71882fg_data *data, u8 reg, u16 val)
+{
+	f71882fg_write8(data, reg,     val >> 8);
+	f71882fg_write8(data, reg + 1, val & 0xff);
+}
 
-/* For models with in1 alarm capability */
-static struct sensor_device_attribute_2 fxxxx_in1_alarm_attr[] = {
-	SENSOR_ATTR_2(in1_max, S_IRUGO|S_IWUSR, show_in_max, store_in_max,
-		0, 1),
-	SENSOR_ATTR_2(in1_beep, S_IRUGO|S_IWUSR, show_in_beep, store_in_beep,
-		0, 1),
-	SENSOR_ATTR_2(in1_alarm, S_IRUGO, show_in_alarm, NULL, 0, 1),
-};
+static u16 f71882fg_read_temp(struct f71882fg_data *data, int nr)
+{
+	if (data->type == f71858fg)
+		return f71882fg_read16(data, F71882FG_REG_TEMP(nr));
+	else
+		return f71882fg_read8(data, F71882FG_REG_TEMP(nr));
+}
 
-/* Fan / PWM attr common to all models */
-static struct sensor_device_attribute_2 fxxxx_fan_attr[4][6] = { {
-	SENSOR_ATTR_2(fan1_input, S_IRUGO, show_fan, NULL, 0, 0),
-	SENSOR_ATTR_2(fan1_full_speed, S_IRUGO|S_IWUSR,
-		      show_fan_full_speed,
-		      store_fan_full_speed, 0, 0),
-	SENSOR_ATTR_2(fan1_alarm, S_IRUGO, show_fan_alarm, NULL, 0, 0),
-	SENSOR_ATTR_2(pwm1, S_IRUGO|S_IWUSR, show_pwm, store_pwm, 0, 0),
-	SENSOR_ATTR_2(pwm1_enable, S_IRUGO|S_IWUSR, show_pwm_enable,
-		      store_pwm_enable, 0, 0),
-	SENSOR_ATTR_2(pwm1_interpolate, S_IRUGO|S_IWUSR,
-		      show_pwm_interpolate, store_pwm_interpolate, 0, 0),
-}, {
-	SENSOR_ATTR_2(fan2_input, S_IRUGO, show_fan, NULL, 0, 1),
-	SENSOR_ATTR_2(fan2_full_speed, S_IRUGO|S_IWUSR,
-		      show_fan_full_speed,
-		      store_fan_full_speed, 0, 1),
-	SENSOR_ATTR_2(fan2_alarm, S_IRUGO, show_fan_alarm, NULL, 0, 1),
-	SENSOR_ATTR_2(pwm2, S_IRUGO|S_IWUSR, show_pwm, store_pwm, 0, 1),
-	SENSOR_ATTR_2(pwm2_enable, S_IRUGO|S_IWUSR, show_pwm_enable,
-		      store_pwm_enable, 0, 1),
-	SENSOR_ATTR_2(pwm2_interpolate, S_IRUGO|S_IWUSR,
-		      show_pwm_interpolate, store_pwm_interpolate, 0, 1),
-}, {
-	SENSOR_ATTR_2(fan3_input, S_IRUGO, show_fan, NULL, 0, 2),
-	SENSOR_ATTR_2(fan3_full_speed, S_IRUGO|S_IWUSR,
-		      show_fan_full_speed,
-		      store_fan_full_speed, 0, 2),
-	SENSOR_ATTR_2(fan3_alarm, S_IRUGO, show_fan_alarm, NULL, 0, 2),
-	SENSOR_ATTR_2(pwm3, S_IRUGO|S_IWUSR, show_pwm, store_pwm, 0, 2),
-	SENSOR_ATTR_2(pwm3_enable, S_IRUGO|S_IWUSR, show_pwm_enable,
-		      store_pwm_enable, 0, 2),
-	SENSOR_ATTR_2(pwm3_interpolate, S_IRUGO|S_IWUSR,
-		      show_pwm_interpolate, store_pwm_interpolate, 0, 2),
-}, {
-	SENSOR_ATTR_2(fan4_input, S_IRUGO, show_fan, NULL, 0, 3),
-	SENSOR_ATTR_2(fan4_full_speed, S_IRUGO|S_IWUSR,
-		      show_fan_full_speed,
-		      store_fan_full_speed, 0, 3),
-	SENSOR_ATTR_2(fan4_alarm, S_IRUGO, show_fan_alarm, NULL, 0, 3),
-	SENSOR_ATTR_2(pwm4, S_IRUGO|S_IWUSR, show_pwm, store_pwm, 0, 3),
-	SENSOR_ATTR_2(pwm4_enable, S_IRUGO|S_IWUSR, show_pwm_enable,
-		      store_pwm_enable, 0, 3),
-	SENSOR_ATTR_2(pwm4_interpolate, S_IRUGO|S_IWUSR,
-		      show_pwm_interpolate, store_pwm_interpolate, 0, 3),
-} };
+static struct f71882fg_data *f71882fg_update_device(struct device *dev)
+{
+	struct f71882fg_data *data = dev_get_drvdata(dev);
+	int nr_fans = f71882fg_nr_fans[data->type];
+	int nr_temps = f71882fg_nr_temps[data->type];
+	int nr, reg, point;
 
-/* Attr for the third fan of the f71808a, which only has manual pwm */
-static struct sensor_device_attribute_2 f71808a_fan3_attr[] = {
-	SENSOR_ATTR_2(fan3_input, S_IRUGO, show_fan, NULL, 0, 2),
-	SENSOR_ATTR_2(fan3_alarm, S_IRUGO, show_fan_alarm, NULL, 0, 2),
-	SENSOR_ATTR_2(pwm3, S_IRUGO|S_IWUSR,
-		      show_simple_pwm, store_simple_pwm, 0, 2),
-};
+	mutex_lock(&data->update_lock);
 
-/* Attr for models which can beep on Fan alarm */
-static struct sensor_device_attribute_2 fxxxx_fan_beep_attr[] = {
-	SENSOR_ATTR_2(fan1_beep, S_IRUGO|S_IWUSR, show_fan_beep,
-		store_fan_beep, 0, 0),
-	SENSOR_ATTR_2(fan2_beep, S_IRUGO|S_IWUSR, show_fan_beep,
-		store_fan_beep, 0, 1),
-	SENSOR_ATTR_2(fan3_beep, S_IRUGO|S_IWUSR, show_fan_beep,
-		store_fan_beep, 0, 2),
-	SENSOR_ATTR_2(fan4_beep, S_IRUGO|S_IWUSR, show_fan_beep,
-		store_fan_beep, 0, 3),
-};
+	/* Update once every 60 seconds */
+	if (time_after(jiffies, data->last_limits + 60 * HZ) ||
+			!data->valid) {
+		if (f71882fg_has_in1_alarm[data->type]) {
+			if (data->type == f81866a) {
+				data->in1_max =
+					f71882fg_read8(data,
+						       F81866_REG_IN1_HIGH);
+				data->in_beep =
+					f71882fg_read8(data,
+						       F81866_REG_IN_BEEP);
+			} else {
+				data->in1_max =
+					f71882fg_read8(data,
+						       F71882FG_REG_IN1_HIGH);
+				data->in_beep =
+					f71882fg_read8(data,
+						       F71882FG_REG_IN_BEEP);
+			}
+		}
 
-/*
- * PWM attr for the f71862fg, fewer pwms and fewer zones per pwm than the
- * standard models
- */
-static struct sensor_device_attribute_2 f71862fg_auto_pwm_attr[3][7] = { {
-	SENSOR_ATTR_2(pwm1_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 0),
-}, {
-	SENSOR_ATTR_2(pwm2_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 1),
-}, {
-	SENSOR_ATTR_2(pwm3_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 2),
-} };
+		/* Get High & boundary temps*/
+		for (nr = data->temp_start; nr < nr_temps + data->temp_start;
+									nr++) {
+			data->temp_ovt[nr] = f71882fg_read8(data,
+						F71882FG_REG_TEMP_OVT(nr));
+			data->temp_high[nr] = f71882fg_read8(data,
+						F71882FG_REG_TEMP_HIGH(nr));
+		}
 
-/*
- * PWM attr for the f71808e/f71869, almost identical to the f71862fg, but the
- * pwm setting when the temperature is above the pwmX_auto_point1_temp can be
- * programmed instead of being hardcoded to 0xff
- */
-static struct sensor_device_attribute_2 f71869_auto_pwm_attr[3][8] = { {
-	SENSOR_ATTR_2(pwm1_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 0),
-	SENSOR_ATTR_2(pwm1_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 0),
-}, {
-	SENSOR_ATTR_2(pwm2_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 1),
-	SENSOR_ATTR_2(pwm2_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 1),
-}, {
-	SENSOR_ATTR_2(pwm3_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 2),
-	SENSOR_ATTR_2(pwm3_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 2),
-} };
+		if (data->type != f8000) {
+			data->temp_hyst[0] = f71882fg_read8(data,
+						F71882FG_REG_TEMP_HYST(0));
+			data->temp_hyst[1] = f71882fg_read8(data,
+						F71882FG_REG_TEMP_HYST(1));
+		}
+		/* All but the f71858fg / f8000 have this register */
+		if ((data->type != f71858fg) && (data->type != f8000)) {
+			reg  = f71882fg_read8(data, F71882FG_REG_TEMP_TYPE);
+			data->temp_type[1] = (reg & 0x02) ? 2 : 4;
+			data->temp_type[2] = (reg & 0x04) ? 2 : 4;
+			data->temp_type[3] = (reg & 0x08) ? 2 : 4;
+		}
 
-/* PWM attr for the standard models */
-static struct sensor_device_attribute_2 fxxxx_auto_pwm_attr[4][14] = { {
-	SENSOR_ATTR_2(pwm1_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 0),
-	SENSOR_ATTR_2(pwm1_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 0),
-	SENSOR_ATTR_2(pwm1_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 0),
-	SENSOR_ATTR_2(pwm1_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 0),
-	SENSOR_ATTR_2(pwm1_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 0),
-	SENSOR_ATTR_2(pwm1_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 0),
-	SENSOR_ATTR_2(pwm1_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 0),
-	SENSOR_ATTR_2(pwm1_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 0),
-	SENSOR_ATTR_2(pwm1_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 0),
-	SENSOR_ATTR_2(pwm1_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 0),
-}, {
-	SENSOR_ATTR_2(pwm2_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 1),
-	SENSOR_ATTR_2(pwm2_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 1),
-	SENSOR_ATTR_2(pwm2_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 1),
-	SENSOR_ATTR_2(pwm2_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 1),
-	SENSOR_ATTR_2(pwm2_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 1),
-	SENSOR_ATTR_2(pwm2_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 1),
-	SENSOR_ATTR_2(pwm2_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 1),
-	SENSOR_ATTR_2(pwm2_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 1),
-	SENSOR_ATTR_2(pwm2_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 1),
-	SENSOR_ATTR_2(pwm2_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 1),
-}, {
-	SENSOR_ATTR_2(pwm3_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 2),
-	SENSOR_ATTR_2(pwm3_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 2),
-	SENSOR_ATTR_2(pwm3_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 2),
-	SENSOR_ATTR_2(pwm3_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 2),
-	SENSOR_ATTR_2(pwm3_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 2),
-	SENSOR_ATTR_2(pwm3_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 2),
-	SENSOR_ATTR_2(pwm3_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 2),
-	SENSOR_ATTR_2(pwm3_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 2),
-	SENSOR_ATTR_2(pwm3_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 2),
-	SENSOR_ATTR_2(pwm3_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 2),
-}, {
-	SENSOR_ATTR_2(pwm4_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 3),
-	SENSOR_ATTR_2(pwm4_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 3),
-	SENSOR_ATTR_2(pwm4_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 3),
-	SENSOR_ATTR_2(pwm4_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 3),
-	SENSOR_ATTR_2(pwm4_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 3),
-	SENSOR_ATTR_2(pwm4_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 3),
-	SENSOR_ATTR_2(pwm4_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 3),
-	SENSOR_ATTR_2(pwm4_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 3),
-	SENSOR_ATTR_2(pwm4_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 3),
-	SENSOR_ATTR_2(pwm4_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 3),
-	SENSOR_ATTR_2(pwm4_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 3),
-	SENSOR_ATTR_2(pwm4_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 3),
-	SENSOR_ATTR_2(pwm4_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 3),
-	SENSOR_ATTR_2(pwm4_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 3),
-} };
+		if (f71882fg_fan_has_beep[data->type])
+			data->fan_beep = f71882fg_read8(data,
+						F71882FG_REG_FAN_BEEP);
 
-/* Fan attr specific to the f8000 (4th fan input can only measure speed) */
-static struct sensor_device_attribute_2 f8000_fan_attr[] = {
-	SENSOR_ATTR_2(fan4_input, S_IRUGO, show_fan, NULL, 0, 3),
-};
-
-/*
- * PWM attr for the f8000, zones mapped to temp instead of to pwm!
- * Also the register block at offset A0 maps to TEMP1 (so our temp2, as the
- * F8000 starts counting temps at 0), B0 maps the TEMP2 and C0 maps to TEMP0
- */
-static struct sensor_device_attribute_2 f8000_auto_pwm_attr[3][14] = { {
-	SENSOR_ATTR_2(pwm1_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 0),
-	SENSOR_ATTR_2(temp1_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 2),
-	SENSOR_ATTR_2(temp1_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 2),
-	SENSOR_ATTR_2(temp1_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 2),
-	SENSOR_ATTR_2(temp1_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 2),
-	SENSOR_ATTR_2(temp1_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 2),
-	SENSOR_ATTR_2(temp1_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 2),
-	SENSOR_ATTR_2(temp1_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 2),
-	SENSOR_ATTR_2(temp1_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 2),
-	SENSOR_ATTR_2(temp1_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 2),
-	SENSOR_ATTR_2(temp1_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 2),
-	SENSOR_ATTR_2(temp1_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 2),
-	SENSOR_ATTR_2(temp1_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 2),
-	SENSOR_ATTR_2(temp1_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 2),
-}, {
-	SENSOR_ATTR_2(pwm2_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 1),
-	SENSOR_ATTR_2(temp2_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 0),
-	SENSOR_ATTR_2(temp2_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 0),
-	SENSOR_ATTR_2(temp2_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 0),
-	SENSOR_ATTR_2(temp2_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 0),
-	SENSOR_ATTR_2(temp2_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 0),
-	SENSOR_ATTR_2(temp2_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 0),
-	SENSOR_ATTR_2(temp2_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 0),
-	SENSOR_ATTR_2(temp2_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 0),
-	SENSOR_ATTR_2(temp2_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 0),
-	SENSOR_ATTR_2(temp2_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 0),
-	SENSOR_ATTR_2(temp2_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 0),
-	SENSOR_ATTR_2(temp2_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 0),
-	SENSOR_ATTR_2(temp2_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 0),
-}, {
-	SENSOR_ATTR_2(pwm3_auto_channels_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_channel,
-		      store_pwm_auto_point_channel, 0, 2),
-	SENSOR_ATTR_2(temp3_auto_point1_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      0, 1),
-	SENSOR_ATTR_2(temp3_auto_point2_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      1, 1),
-	SENSOR_ATTR_2(temp3_auto_point3_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      2, 1),
-	SENSOR_ATTR_2(temp3_auto_point4_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      3, 1),
-	SENSOR_ATTR_2(temp3_auto_point5_pwm, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_pwm, store_pwm_auto_point_pwm,
-		      4, 1),
-	SENSOR_ATTR_2(temp3_auto_point1_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      0, 1),
-	SENSOR_ATTR_2(temp3_auto_point2_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      1, 1),
-	SENSOR_ATTR_2(temp3_auto_point3_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      2, 1),
-	SENSOR_ATTR_2(temp3_auto_point4_temp, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp, store_pwm_auto_point_temp,
-		      3, 1),
-	SENSOR_ATTR_2(temp3_auto_point1_temp_hyst, S_IRUGO|S_IWUSR,
-		      show_pwm_auto_point_temp_hyst,
-		      store_pwm_auto_point_temp_hyst,
-		      0, 1),
-	SENSOR_ATTR_2(temp3_auto_point2_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 1, 1),
-	SENSOR_ATTR_2(temp3_auto_point3_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 2, 1),
-	SENSOR_ATTR_2(temp3_auto_point4_temp_hyst, S_IRUGO,
-		      show_pwm_auto_point_temp_hyst, NULL, 3, 1),
-} };
-
-/* Super I/O functions */
-static inline int superio_inb(int base, int reg)
-{
-	outb(reg, base);
-	return inb(base + 1);
-}
-
-static int superio_inw(int base, int reg)
-{
-	int val;
-	val  = superio_inb(base, reg) << 8;
-	val |= superio_inb(base, reg + 1);
-	return val;
-}
-
-static inline int superio_enter(int base)
-{
-	/* Don't step on other drivers' I/O space by accident */
-	if (!request_muxed_region(base, 2, DRVNAME)) {
-		pr_err("I/O address 0x%04x already in use\n", base);
-		return -EBUSY;
-	}
-
-	/* according to the datasheet the key must be send twice! */
-	outb(SIO_UNLOCK_KEY, base);
-	outb(SIO_UNLOCK_KEY, base);
-
-	return 0;
-}
-
-static inline void superio_select(int base, int ld)
-{
-	outb(SIO_REG_LDSEL, base);
-	outb(ld, base + 1);
-}
-
-static inline void superio_exit(int base)
-{
-	outb(SIO_LOCK_KEY, base);
-	release_region(base, 2);
-}
-
-static inline int fan_from_reg(u16 reg)
-{
-	return reg ? (1500000 / reg) : 0;
-}
-
-static inline u16 fan_to_reg(int fan)
-{
-	return fan ? (1500000 / fan) : 0;
-}
-
-static u8 f71882fg_read8(struct f71882fg_data *data, u8 reg)
-{
-	u8 val;
-
-	outb(reg, data->addr + ADDR_REG_OFFSET);
-	val = inb(data->addr + DATA_REG_OFFSET);
-
-	return val;
-}
-
-static u16 f71882fg_read16(struct f71882fg_data *data, u8 reg)
-{
-	u16 val;
-
-	val  = f71882fg_read8(data, reg) << 8;
-	val |= f71882fg_read8(data, reg + 1);
-
-	return val;
-}
-
-static void f71882fg_write8(struct f71882fg_data *data, u8 reg, u8 val)
-{
-	outb(reg, data->addr + ADDR_REG_OFFSET);
-	outb(val, data->addr + DATA_REG_OFFSET);
-}
-
-static void f71882fg_write16(struct f71882fg_data *data, u8 reg, u16 val)
-{
-	f71882fg_write8(data, reg,     val >> 8);
-	f71882fg_write8(data, reg + 1, val & 0xff);
-}
-
-static u16 f71882fg_read_temp(struct f71882fg_data *data, int nr)
-{
-	if (data->type == f71858fg)
-		return f71882fg_read16(data, F71882FG_REG_TEMP(nr));
-	else
-		return f71882fg_read8(data, F71882FG_REG_TEMP(nr));
-}
-
-static struct f71882fg_data *f71882fg_update_device(struct device *dev)
-{
-	struct f71882fg_data *data = dev_get_drvdata(dev);
-	int nr_fans = f71882fg_nr_fans[data->type];
-	int nr_temps = f71882fg_nr_temps[data->type];
-	int nr, reg, point;
-
-	mutex_lock(&data->update_lock);
-
-	/* Update once every 60 seconds */
-	if (time_after(jiffies, data->last_limits + 60 * HZ) ||
-			!data->valid) {
-		if (f71882fg_has_in1_alarm[data->type]) {
-			if (data->type == f81866a) {
-				data->in1_max =
-					f71882fg_read8(data,
-						       F81866_REG_IN1_HIGH);
-				data->in_beep =
-					f71882fg_read8(data,
-						       F81866_REG_IN_BEEP);
-			} else {
-				data->in1_max =
-					f71882fg_read8(data,
-						       F71882FG_REG_IN1_HIGH);
-				data->in_beep =
-					f71882fg_read8(data,
-						       F71882FG_REG_IN_BEEP);
-			}
-		}
-
-		/* Get High & boundary temps*/
-		for (nr = data->temp_start; nr < nr_temps + data->temp_start;
-									nr++) {
-			data->temp_ovt[nr] = f71882fg_read8(data,
-						F71882FG_REG_TEMP_OVT(nr));
-			data->temp_high[nr] = f71882fg_read8(data,
-						F71882FG_REG_TEMP_HIGH(nr));
-		}
-
-		if (data->type != f8000) {
-			data->temp_hyst[0] = f71882fg_read8(data,
-						F71882FG_REG_TEMP_HYST(0));
-			data->temp_hyst[1] = f71882fg_read8(data,
-						F71882FG_REG_TEMP_HYST(1));
-		}
-		/* All but the f71858fg / f8000 have this register */
-		if ((data->type != f71858fg) && (data->type != f8000)) {
-			reg  = f71882fg_read8(data, F71882FG_REG_TEMP_TYPE);
-			data->temp_type[1] = (reg & 0x02) ? 2 : 4;
-			data->temp_type[2] = (reg & 0x04) ? 2 : 4;
-			data->temp_type[3] = (reg & 0x08) ? 2 : 4;
-		}
-
-		if (f71882fg_fan_has_beep[data->type])
-			data->fan_beep = f71882fg_read8(data,
-						F71882FG_REG_FAN_BEEP);
-
-		if (f71882fg_temp_has_beep[data->type])
-			data->temp_beep = f71882fg_read8(data,
-						F71882FG_REG_TEMP_BEEP);
+		if (f71882fg_temp_has_beep[data->type])
+			data->temp_beep = f71882fg_read8(data,
+						F71882FG_REG_TEMP_BEEP);
 
 		data->pwm_enable = f71882fg_read8(data,
 						  F71882FG_REG_PWM_ENABLE);
